Menu

## Footnotes_Layout_Engine

layout.php : 22

Layout Engine for the administration dashboard.

##### Tags

since
  1.5.0

### Table of Contents

$a_arr_sections : array<string|int, mixed>
  Stores all Sections for the child sub page.
$a_str_sub_page_hook : null|string
  Stores the Hook connection string for the child sub page.
description() : mixed
  Output the Description of a section. May be overwritten in any section.
display_content() : mixed
  Displays the content of specific sub page.
get_priority() : int
  Returns a Priority index. Lower numbers have a higher Priority.
register_sections() : mixed
  Registers all sections for a sub page.
register_sub_page() : mixed
  Registers a sub page.
add_checkbox() : string
  Returns the html tag for an input [type = checkbox].
add_color_selection() : string
  Returns the html tag for an input [type = text] with color selection class.
add_label() : string
  Returns the html tag for an input/select label.
add_line_space() : string
  Returns a line break to have a space between two lines.
add_meta_box() : array<string|int, mixed>
  Returns an array describing a meta box.
add_newline() : string
  Returns a line break to start a new line.
add_num_box() : string
  Returns the html tag for an input [type = num].
add_section() : array<string|int, mixed>
  Returns an array describing a sub page section.
add_select_box() : string
  Returns the html tag for a select box.
add_text() : string
  Returns a simple text inside html <span> text.
add_text_box() : string
  Returns the html tag for an input [type = text].
add_textarea() : string
  Returns the html tag for a text area.
get_meta_boxes() : array<string|int, mixed>
  Returns an array of all registered meta boxes.
get_sections() : array<string|int, mixed>
  Returns an array of all registered sections for a sub page.
get_sub_page_slug() : string
  Returns the unique slug of the child sub page.
get_sub_page_title() : string
  Returns the title of the child sub page.
load_setting() : array<string|int, mixed>
  Loads specific setting and returns an array with the keys [id, name, value].
append_scripts() : mixed
  Append javascript and css files for specific sub page.
register_meta_boxes() : mixed
  Registers all Meta boxes for a sub page.
save_settings() : bool
  Save all Plugin settings.

### Properties

#### $a_arr_sections

layout.php : 38

Stores all Sections for the child sub page.

`protected array<string|int, mixed> $a_arr_sections = array()`

##### Tags

since
  1.5.0

#### $a_str_sub_page_hook

layout.php : 30

Stores the Hook connection string for the child sub page.

`protected null|string $a_str_sub_page_hook = ull`

##### Tags

since
  1.5.0

### Methods

#### description()

layout.php : 331

Output the Description of a section. May be overwritten in any section.

`public description() : mixed`

##### Tags

since
  1.5.0

##### Return values

mixed —

#### display_content()

layout.php : 231

Displays the content of specific sub page.

`public display_content() : mixed`

##### Tags

since
  1.5.0

##### Return values

mixed —

#### get_priority()

layout.php : 46

Returns a Priority index. Lower numbers have a higher Priority.

`public abstract get_priority() : int`

##### Tags

since
  1.5.0

##### Return values

int —

#### register_sections()

layout.php : 149

Registers all sections for a sub page.

`public register_sections() : mixed`

##### Tags

since
  1.5.0

##### Return values

mixed —

#### register_sub_page()

layout.php : 123

Registers a sub page.

`public register_sub_page() : mixed`

##### Tags

since
  1.5.0

##### Return values

mixed —

#### add_checkbox()

layout.php : 459

Returns the html tag for an input [type = checkbox].

`protected add_checkbox(string $p_str_setting_name) : string`

##### Parameters

$p_str_setting_name : string

  Name of the Settings key to pre load the input field.

##### Tags

since
  1.5.0

##### Return values

string —

#### add_color_selection()

layout.php : 535

Returns the html tag for an input [type = text] with color selection class.

`protected add_color_selection(string $p_str_setting_name) : string`

##### Parameters

$p_str_setting_name : string

  Name of the Settings key to pre load the input field.

##### Tags

since
  1.5.6

##### Return values

string —

#### add_label()

layout.php : 406

Returns the html tag for an input/select label.

`protected add_label(string $p_str_setting_name, string $p_str_caption) : string`

##### Parameters

$p_str_setting_name : string

  Name of the Settings key to connect the Label with the input/select field.

$p_str_caption : string

  Label caption.

##### Tags

since
  1.5.0

##### Return values

string —

#### add_line_space()

layout.php : 383

Returns a line break to have a space between two lines.

`protected add_line_space() : string`

##### Tags

since
  1.5.0

##### Return values

string —

#### add_meta_box()

layout.php : 109

Returns an array describing a meta box.

`protected add_meta_box(string $p_str_section_id, string $p_str_id, string $p_str_title, string $p_str_callback_function_name) : array<string|int, mixed>`

##### Parameters

$p_str_section_id : string

  Parent Section ID.

$p_str_id : string

  Unique ID suffix.

$p_str_title : string

  Title for the meta box.

$p_str_callback_function_name : string

  Class method name for callback.

##### Tags

since
  1.5.0

##### Return values

array<string|int, mixed> —

meta box description to be able to append a meta box to the output.

#### add_newline()

layout.php : 373

Returns a line break to start a new line.

`protected add_newline() : string`

##### Tags

since
  1.5.0

##### Return values

string —

#### add_num_box()

layout.php : 559

Returns the html tag for an input [type = num].

`protected add_num_box(string $p_str_setting_name, int $p_in_min, int $p_int_max[, bool $p_bool_deci = false ]) : string`

##### Parameters

$p_str_setting_name : string

  Name of the Settings key to pre load the input field.

$p_in_min : int

  Minimum value.

$p_int_max : int

  Maximum value.

$p_bool_deci : bool = false

  true if 0.1 steps and floating to string, false if integer (default).

##### Tags

since
  1.5.0
since
  2.1.4

  step argument and number_format() to allow decimals ..

##### Return values

string —

Edited:

#### add_section()

layout.php : 90

Returns an array describing a sub page section.

`protected add_section(string $p_str_id, string $p_str_title, int $p_int_settings_container_index[, bool $p_bool_has_submit_button = true ]) : array<string|int, mixed>`

##### Parameters

$p_str_id : string

  Unique ID suffix.

$p_str_title : string

  Title of the section.

$p_int_settings_container_index : int

  Settings Container Index.

$p_bool_has_submit_button : bool = true

  Should a Submit Button be displayed for this section, default: true.

##### Tags

since
  1.5.0

##### Return values

array<string|int, mixed> —

Array describing the section.

#### add_select_box()

layout.php : 487

Returns the html tag for a select box.

`protected add_select_box(string $p_str_setting_name, array<string|int, mixed> $p_arr_options) : string`

##### Parameters

$p_str_setting_name : string

  Name of the Settings key to pre select the current value.

$p_arr_options : array<string|int, mixed>

  Possible options to be selected.

##### Tags

since
  1.5.0
  - Bugfix: Dashboard: Referrers and tooltips: Backlink symbol: debug select box by reverting identity check to equality check, thanks to @lolzim bug report.
since
  2.5.13
since
  2.5.15

  Bugfix: Dashboard: General settings: Footnote start and end short codes: debug select box for shortcodes with pointy brackets.

since
  2.6.1

  Restore esc_attr() in load_setting(), remove htmlspecialchars() here.

reporter

  @lolzim

##### Return values

string —

#### add_text()

layout.php : 394

Returns a simple text inside html <span> text.

`protected add_text(string $p_str_text) : string`

##### Parameters

$p_str_text : string

  Message to be surrounded with simple html tag (span).

##### Tags

since
  1.5.0

##### Return values

string —

#### add_text_box()

layout.php : 434

Returns the html tag for an input [type = text].

`protected add_text_box(string $p_str_setting_name[, int $p_str_max_length = 999 ][, bool $p_bool_readonly = false ][, bool $p_bool_hidden = false ]) : string`

##### Parameters

$p_str_setting_name : string

  Name of the Settings key to pre load the input field.

$p_str_max_length : int = 999

  Maximum length of the input, default 999 characters.

$p_bool_readonly : bool = false

  Set the input to be read only, default false.

$p_bool_hidden : bool = false

  Set the input to be hidden, default false.

##### Tags

since
  1.5.0

##### Return values

string —

#### add_textarea()

layout.php : 517

Returns the html tag for a text area.

`protected add_textarea(string $p_str_setting_name) : string`

##### Parameters

$p_str_setting_name : string

  Name of the Settings key to pre fill the text area.

##### Tags

since
  1.5.0

##### Return values

string —

#### get_meta_boxes()

layout.php : 78

Returns an array of all registered meta boxes.

`protected abstract get_meta_boxes() : array<string|int, mixed>`

##### Tags

since
  1.5.0

##### Return values

array<string|int, mixed> —

#### get_sections()

layout.php : 70

Returns an array of all registered sections for a sub page.

`protected abstract get_sections() : array<string|int, mixed>`

##### Tags

since
  1.5.0

##### Return values

array<string|int, mixed> —

#### get_sub_page_slug()

layout.php : 54

Returns the unique slug of the child sub page.

`protected abstract get_sub_page_slug() : string`

##### Tags

since
  1.5.0

##### Return values

string —

#### get_sub_page_title()

layout.php : 62

Returns the title of the child sub page.

`protected abstract get_sub_page_title() : string`

##### Tags

since
  1.5.0

##### Return values

string —

#### load_setting()

layout.php : 357

Loads specific setting and returns an array with the keys [id, name, value].

`protected load_setting(string $p_str_setting_key_name) : array<string|int, mixed>`

##### Parameters

$p_str_setting_key_name : string

  Settings Array key name.

##### Tags

since
  1.5.0
since
  2.5.11

  Remove escapement function. When refactoring the codebase after 2.5.8, all and every output was escaped. After noticing that the plugin was broken, all escapement functions were removed.

since
  2.5.15

  To fix it, the data was escaped in add_select_box() instead.

since
  2.6.1

  Restore esc_attr() in load_setting().

link
  https://github.com/markcheret/footnotes/pull/50/commits/25c3f2f12eb5de1079e9215bf624ec4289b095a5
link

  In that process, this instance of esc_attr() was removed too, so the plugin was broken again.

link
  https://github.com/markcheret/footnotes/pull/50/commits/25c3f2f12eb5de1079e9215bf624ec4289b095a5#diff-a8ed6e859c32a18fc10bbbad3b4dd8ce7f43f2378d29471c7638e314ab30f1bdL349-L354
see
  add_select_box()

  This is the only instance of esc_|kses|sanitize in the pre-2.5.11 codebase. Removing this did not fix the quotation mark backslash escapement bug.

##### Return values

array<string|int, mixed> —

Contains Settings ID, Settings Name and Settings Value.

#### append_scripts()

layout.php : 190

Append javascript and css files for specific sub page.

`private append_scripts() : mixed`

##### Tags

since
  1.5.0

##### Return values

mixed —

#### register_meta_boxes()

layout.php : 169

Registers all Meta boxes for a sub page.

`private register_meta_boxes(string $p_str_parent_id) : mixed`

##### Parameters

$p_str_parent_id : string

  Parent section unique id.

##### Tags

since
  1.5.0

##### Return values

mixed —

#### save_settings()

layout.php : 303

Save all Plugin settings.

`private save_settings() : bool`

##### Tags

since
  1.5.0

##### Return values

bool —

## Search results